Subject: Re: Soft lock-ups caused by iptables

From: Phil Sutter <[email-masked]>
Date: Wed, 19 Nov 2025 19:12:37 +0100

On Wed, Nov 19, 2025 at 04:58:46PM +0100, Florian Westphal wrote:
> Phil Sutter <[email-masked]> wrote:
> > On nftables side, maybe we could annotate chains with a depth value once
> > validated to skip digging into them again when revisiting from another
> > jump?
> 
> Yes, but you also need to annotate the type of the last base chain origin,
> else you might skip validation of 'chain foo' because its depth value says its
> fine but new caller is coming from filter, not nat, and chain foo had
> masquerade expression.

There would need to be masks of valid types and hooks recording the
restrictions imposed on a non-base chain by its rules' expressions.
Maybe this even needs a matrix for cases where some hooks are OK in some
families/types but not others.

Cheers, Phil